from threading import Thread
from time import sleep
from core.nao_motion import naoMotion
from naoqi import ALProxy

import sys, os
from PyQt4.QtGui import QApplication
from core.nao_vision import naoVision

global memory, vision, CameraID

if len(sys.argv) > 1:
    CameraID = int(sys.argv[1])
    print "CameraID ",CameraID
else:
    CameraID = 1

#IP = "127.0.0.1"
IP = "192.168.1.129"
PORT = 9559


#init modules
motion = naoMotion(IP, PORT)

def f3():
    global vision, app
  
    app = QApplication(sys.argv)

    vision = naoVision(IP, PORT, CameraID, "vv")
    vision.initWidget()
    vision._imgWidget.showGrid()
    vision._imgWidget.showCalibrationCircle(120)
    vision.displayCamera()
    
    exit(app.exec_())         

def f1():
    global memory, vision, app, CameraID
    memory = ALProxy("ALMemory", IP, PORT)
    centroid = None
    while True:
        if memory.getData("Device/SubDeviceList/Head/Touch/Front/Sensor/Value") > 0:
            if CameraID == 0:
                motion.moveXSquare(0.65, 1)
            else:
                motion.stepForward()
            error = -1;
            sleep(2)
            while(error != 0):
                #default 165,175
                centroid = vision.getCentroid(vision.getPicture(), 163, 180)
                error = motion.reposition(centroid)
        if memory.getData("Device/SubDeviceList/Head/Touch/Rear/Sensor/Value") > 0:
            area = 0
            while area != 6 or area != 7:
                centroid = vision.getCentroid(vision.getPicture(), 165, 175)
                area = motion._positioning.lateralAproach(centroid)
        if memory.getData("Device/SubDeviceList/Head/Touch/Middle/Sensor/Value") > 0:
            area = 0
            while area != 6 and area != 7:
                centroid = vision.getCentroid(vision.getPicture(), 165, 175)
                area = motion.getBestMove(centroid, CameraID)
                if area == -1:
                    print "changing camera and restarting video"
                    app.closeAllWindows()
                    app.exit()
                    app.quit() 
                    exit()
                error = -1;
                sleep(2)
                print "Current area: "+str(area)
                #calculate error only if object is away
                while(error != 0 and area >= 1):
                    centroid = vision.getCentroid(vision.getPicture(), 165, 175)
                    error = motion.reposition(centroid)
                #area = motion._positoning.bestMove(centroid)
    
def f2():
    memory = ALProxy("ALMemory", IP, PORT)
    
    motion.loadMotion()
    motion.loadPosture()
    
    #motion.setStiffnesses("Body", 1, 5)
    print "Using Camera ", CameraID
    if(CameraID == 0):
        motion.goToPosture("StandInit", 1)
        print "StandInit, head down!"
        motion.headPitchDownwards([0.05, 0.10, 0.15])
        sleep(2)
    else:
        print "Head up!"
        motion.headPitchDownwards([-0.05, -0.10, -0.15])
        sleep(2)
    print "Ready to go"
    #print motion.getAngles("Head", False)
    #motion.setWalkTargetVelocity(0.7, 0.7, 0.7, 1)
    #motion.stopMove()
    

    #motion.headPitchDownwards()
    
    #lside.main(IP, PORT)

        
def f4():
    sleep(3)
    global vision
    vision._imgWidget.filter(165, 175)

def f5():
    os.system("PositionYourself!.py 1")

if __name__ == '__main__':
    
    try:
        t1 = Thread(target=f1)
        t2 = Thread(target=f2)
        t3 = Thread(target=f3) 
        t4 = Thread(target=f4)

        t1.start()
        t2.start()
        t3.start()
        t4.start()

    
    except BaseException, err:
        print err