from threading import Thread
from time import sleep
from core.nao_motion import naoMotion

from naoqi import ALProxy

global memory

#IP = "127.0.0.1"  # Replace here with your NaoQi's IP address.
IP = "192.168.1.129"
PORT = 9559

motion = naoMotion(IP, PORT)


def f1():
    memory = ALProxy("ALMemory", IP, PORT)
    while True:
        if memory.getData("Device/SubDeviceList/Head/Touch/Front/Sensor/Value") > 0:
            motion.turnRight()
        if memory.getData("Device/SubDeviceList/Head/Touch/Rear/Sensor/Value") > 0:
            motion.turnLeft()
        if memory.getData("Device/SubDeviceList/Head/Touch/Middle/Sensor/Value") > 0:
            motion.moveXSquare(0.65, 0.5)

    
def f2():
    memory = ALProxy("ALMemory", IP, PORT)
    
    motion.loadMotion()
    motion.loadPosture()
    
    motion.setStiffnesses("Body", 1.0)
    
    motion.goToPosture("StandInit", 0.7)
        
    sleep(2)
    motion.setWalkTargetVelocity(0.7, 0.7, 0.7, 1)
    motion.stopMove()

    #motion.moveXSquare(1)
    
    #sleep(8)
    

def f3(arg1, stop_event):
    sleep(3)
    memory = ALProxy("ALMemory", IP, PORT)
    while(not stop_event.is_set()):
        print "X: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeX/Sensor/Value")
        print "Y: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeY/Sensor/Value")
        print "Z: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeZ/Sensor/Value")
        stop_event.wait(0.2)    

if __name__ == '__main__':
    try:
        t1 = Thread(target=f1)
        t2 = Thread(target=f2)
        #t3 = Thread(target=f3) 

        t1.start()
        t2.start()
        #t3.start()

    
    except BaseException, err:
        print err