import sys
from PyQt4.QtGui import QApplication
from vision import ColorTracker
from core.nao_vision import naoVision 
from naoqi import ALProxy
from threading import Thread
from time import sleep


sensor = None
#IP = "127.0.0.1"  # Replace here with your NaoQi's IP address.
IP = "192.168.1.129"
PORT = 9559
CameraID = 0

sensor = ALProxy("ALSensors", IP, PORT)
sensor.subscribe("sensor")
memory = ALProxy("ALMemory", IP, PORT)
ct = None
hsvImage = None
Radius1 = 110
Radius2 = 60

def f1():
    app = QApplication(sys.argv)
    global vision
    vision = naoVision(IP, PORT, CameraID)
    vision._imgWidget.showCalibrationCircle(Radius1)
    #vision._imgWidget.showGrid()
    vision.displayCamera()
        
    global sensor
    
    sensor.run()
         
    sys.exit(app.exec_())
    
    
def f2():
    ct = ColorTracker.ColorTracker()
    counter = 0
    photo1 = None
    photo2 = None
    sleep(3)
    image = vision.getFrame()
    hsvImage = ct.toHSV(image)
    image.save("../../images/calibration1d.png", "PNG")
    photo1 = ct.meanColorCirumference(hsvImage, Radius1, 20)
    #print photo1
    image = vision.getFrame()
    hsvImage = ct.toHSV(image)
    image.save("../../images/longshot.png", "PNG")
    counter = counter + 1
    #print photo2
    vision._imgWidget.showCalibrationCircle(Radius2)
    sleep(8)
    counter = counter + 1
    image = vision.getFrame()
    hsvImage = ct.toHSV(image)
    photo2 = ct.meanColorCirumference(hsvImage, Radius2, 20)
    image.save("../../images/calibration2d.png", "PNG")

    range = ct.getRange(photo2, 10)
    print range

if __name__ == '__main__': 
    try:
        t1 = Thread(target=f1)
        t2 = Thread(target=f2)
        t1.start()
        t2.start()
    
    except BaseException, err:
        print err