#!/usr/bin/env python

#
# Python node to load behaviours into Nao
# This code is currently compatible to NaoQI version 1.12.3
#
# Copyright 2012 - 2014 Moises Martinez, University Carlos III
#			2014 Marcos Zimmermann Casado, University Carlos III
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#    # Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#    # Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#    # Neither the name of the Unversity Carlos III nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

import roslib

roslib.load_manifest('nao_core')

import rospy

from nao_node import *

class behaviour():
	
	def __init__(self, name, file):
		
		self.name   = name
		self.angles = list()
		self.times  = list()
		self.keys 	= list()

		print('Not defined') 

	def getName(self):
		return self.name
	
	def getAngles(self):
		return self.angles

	def getTimes(self):
		return self.Times

	def getKeys(self):
		return self.Keys


class behaviours():

	def __init__(self):
		self.nodes = list()

	def addBehaviour(self, name, file):
		self.nodes.append(behaviour(name, file))

	def findBehaviour(self, name):
		return None

