# NAO Node. General class to connect to naoqi
# This code is currently compatible to NaoQI version 1.12.3
#
# Copyright 2012 - 2014 Moises Martinez, University Carlos III
#			2014 Marcos Zimmermann Casado, University Carlos III
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#    # Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#    # Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#    # Neither the name of the Unversity Carlos III nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
"""
try:
	from naoqi import ALProxy
except ImportError:
	print "Error importing NaoQI. Please make sure that Aldebaran's NaoQI API is in your PYTHONPATH."
	exit(1)
"""
from naoqi import ALProxy

class naoNode(object):
	def __init__(self, ip, port):

		self.ip = ip
		self.port = port
		

	def connectProxy(self, name):

		proxy = None
		
		try:
			proxy = ALProxy(name, self.ip, self.port)
		except RuntimeError,e:
			print "Could not create Proxy \"%s\"\n.", name
			print "Exception message:\n %s",e
		
		return proxy
	
	def getVersion(self):
		return '1.12.3'
