import time, math

class Positioning(object):
    
    def __init__(self, movement):
        self._movement = movement
        self.imgWidth = 320
        self.imgHeight = 240
        self.steps = 0
        self.totalSteps = 0
    
        """
        ---------
        |A1|A2|A3|
        ----------
        |A4|A5|A6|
        ---------
        """
        #Points for the square, top left corner and bottom right corner
        #[x1, y1, x2, y2, ID] 
        """
        old values
        self.A1 = [0, 0, self.imgWidth/3, self.imgHeight/2, 1]
        self.A2 = [self.imgWidth/3, 0, self.imgWidth*2/3, self.imgHeight/2, 2]
        self.A3 = [self.imgWidth*2/3, 0, self.imgWidth, self.imgHeight/2, 3]
        self.A4 = [0, self.imgHeight/2, self.imgWidth/3, self.imgHeight, 4]
        self.A5 = [self.imgWidth/3, self.imgHeight/2, self.imgWidth*2/3, self.imgHeight, 5]
        self.A6 = [self.imgWidth*2/3, self.imgHeight/2, self.imgWidth/3, self.imgHeight, 6]
        """
    def bestMove(self, centroid):
        area = 0
        if centroid == None:
            print "No centroid"
            if self._movement.isHeadMoved():
                print "Trying with the other position"
                self._movement.headPitchDownwards([-0.25, -0.10, 0])
            else:
                self._movement.stepForward()
            area = 0
            #return 0
        else:
            area = self.centroidToArea(centroid)
        print "The object is in area ", area
        
        if self.steps >= 16 / self._movement.factor:
            print "Forcing catch"
            area = 6
        
        if area == 1:
            self._movement.stepForward()
        elif area == 2:
            self._movement.stepForward()
            #self._movement.stepRight()
        elif area == 3:
            self._movement.stepForward()
            #self._movement.stepRight()
        elif area == 4:
            self._movement.stepForward()
            #self._movement.stepRight()
        elif area == 5:
            self._movement.stepRight()
            return area
        elif area == 6:
            if self._movement.isHeadMoved():
                area = 9 
                self._movement.stepForward()
            else:
                print "Ready to catch"
                self.steps = -1
        elif area == 7:
            if self._movement.isHeadMoved():
                area = 9 
                self._movement.stepForward()
            else: 
                print "Ready to catch"
                self.steps = -1
        elif area == 8:
            self._movement.stepLeft()            
        time.sleep(1)
        if self.steps == 4:
            self._movement.headPitchDownwards([-0.25, -0.10, 0])
        self.steps += 1
        self.totalSteps += 1
        
        if area != 6 and self.steps%3 == 0:
            if area != 7 and self.steps < 10:
                self._movement.turnLeft(rad = math.pi * 10 / 180)
        
        if self.steps >= 8:
            print "Too near to measure error"
            area = 0
            
        
        print "Step n ",self.steps, "Total steps: ", self.totalSteps
        return area;
    
        
    def centroidToArea(self, centroid):
        print "centroid pos: ", centroid
        area = 1;
        if int(centroid[0]) > self.imgWidth/4:
            area = area+1
        if int(centroid[0]) > self.imgWidth/2:
            area = area+1
        if int(centroid[0]) > self.imgWidth*3/4:
            area = area+1
        #if int(centroid[1]) > self.imgHeight/1.8:
        if int(centroid[1]) > self.imgHeight/1.8:
            area = area+4
        return area
    
    def getProximity(self, centroid):
        proximity = 0#Im still far away
        if self._movement.isHeadMoved():
            if centroid is None:
                proximity = -1 #No centroid
            elif int(centroid[1]) > (self.imgHeight*3.5/5):
            #if robot cant see object or is 1/5 bottom of the image
                #Reset head position
                self._movement.headPitchDownwards(joints = [0.3, 0.15, 0.0])
                print "change camera"
                proximity = 1 #Im near so I have to change the camera
        return proximity #Im still far away
    
    def bestAproximation(self):
        self._movement.move
        #move 2 steps forward
        
    
    def isInsideCircle(self, centroid, radius):
        x = (int(centroid[0]) - self.imgWidth/2)^2
        y = (int(centroid[1]) - self.imgHeight/2)^2
        
        if x + y < radius^2:
            return True
        return False

    
    def isBetween(self, centroid, distance):
        if centroid == None:
            print "no centroid"
            return -1
        result = int(centroid[0]) - ((self.imgWidth/2)*1.0)#.25)  
        if abs(result) < distance:
            return 0
        if result < 0:
            return 1
        else:
            return 2
        
    def reposition(self, error):
        if error == 0:
            print "No repositioning"
        elif error == 1:
            print "I have to turn left"
            self._movement.turnLeft(0.1 * self._movement.factor)
        elif error == 2:
            print "I have to turn right"
            self._movement.turnRight(0.1 * self._movement.factor)
        return error
    
    
            
             
        
    