import ColorTracker
import vision_definitions
import ImageWidget
from naoqi import ALProxy
import Color


class NaoVision(object):
    '''
    classdocs
    '''


    def __init__(self, IP, PORT, cameraID):
        self._IP = IP
        self._PORT = PORT
        self._cameraID = cameraID
        self._videoProxy = None
        self._imgClient = None
        self._registerImageClient(self._IP, self._PORT)
        self._colorTracker = ColorTracker.ColorTracker();
        self._imgWidget = ImageWidget.ImageWidget(self._videoProxy, self._imgClient)
        self._colors = []
                
    def _registerImageClient(self, IP, PORT):
        self._videoProxy = ALProxy("ALVideoDevice", IP, PORT)
        resolution = vision_definitions.kQVGA  # 320 * 240
        colorSpace = vision_definitions.kRGBColorSpace
        self._imgClient = self._videoProxy.subscribe("client", resolution, colorSpace, 5)

        # Select camera.
        self._videoProxy.setParam(vision_definitions.kCameraSelectID,
                                  self._cameraID)
        
    def displayCamera(self):
        self._imgWidget.show()
        
    def getFrame(self):
        return self._imgWidget.getPILImage()
    
    def getImage(self):
        return self._videoProxy.getImageRemote()
    
    def addColor(self, color):
        newColor = Color.Color(color)
        self._colors[newColor._id] = newColor
    
    def findObject(self, color_id):
        self._colors[color_id]
    
    def findObjects(self, colors):
        '''
        for color in colors
            self.findObject(color)
        '''
    
    def getObjectPosition(self, color):
        return self._colorTracker.getPosition(self, color, self.getFrame())

    def __del__(self):
        self._videoProxy.unsubscribe(self._imgClient)
    